#!/usr/bin/env ruby
# $Id: extconf.rb,v 1.5 2002/01/22 18:00:08 matju Exp $
# installer for RubyX11 / MetaRuby / etc
# by Mathieu Bouchard

require "rbconfig"
require "ftools"
include Config
#DESTDIR = CONFIG["sitedir"] + "/" + CONFIG["MAJOR"] + "." + CONFIG["MINOR"]
 DESTDIR = "/home/matju/lib/ruby/1.7"
RUBY = "ruby-1.7"

def install_files(f,base,entries)
  entries.each {|type,name,*rest|
    case type
    when :ruby
      f.puts "\tinstall --mode 644 #{base+name} $(DESTDIR)/#{base+name}"
    when :directory
      f.puts "\t@mkdir $(DESTDIR)/#{base+name} || true"
      install_files(f,base+name,rest) 
    end
  }
end

def uninstall_files(f,base,entries)
  entries.each {|type,name,*rest|
    case type
    when :ruby
      f.puts "\trm $(DESTDIR)/#{base+name}"
    when :directory
      uninstall_files(f,base+name,rest) 
    end
  }
end

def make_makefile
  File.open("Makefile","w") {|f|
    f.puts "# Warning: this file is GENERATED by ./extconf.rb", ""
    f.puts "DESTDIR = #{DESTDIR}", ""
    f.puts "RUBY = #{RUBY}"
    f.puts "all::", ""
    f.puts "Makefile: extconf.rb"
    f.puts "\t$(RUBY) extconf.rb", ""

    f.puts "install::"
    install_files(f,"",FILES)
    f.puts
    f.puts "uninstall::"
    uninstall_files(f,"",FILES)
    f.puts
  }
  #FILES.each {|name|
  #  File.install "lib/#{name}", "#{DSTPATH}/#{name}", 0644, true   
  #end
end

#----------------------------------------------------------------#

FILES = [
  [:directory, "X11/",
    [:ruby, "Base.rb"],
    [:ruby, "Contract.rb"],
    [:ruby, "Display.rb"],
    [:ruby, "Event.rb"],
    [:ruby, "Keysyms.rb"],
    [:ruby, "Marshal.rb"],
    [:ruby, "Remote.rb"],
    [:ruby, "Type.rb"],
    [:ruby, "XID.rb"],
  ],
]

make_makefile
