#!/usr/bin/ruby

require "X11/Auth"


raise "LOL"

__END__

module X11; module Protocol

def hexi(x)
	sprintf("0x%x", x);
end

(pack("L", 0)).length == 4 or raise "sizeof(int) != 4"

def give(*x)
	@connection.give(*x)
end

def get(*x)
	@connection.get(*x)
end

def interp(*x)
	return x[0] unless @do_interp
	return do_interp(*x)
end

def do_interp(type,num)
	raise "Unknown constant type `#{type}'" unless
		@const.has_key?(type) or
		@ext_const.has_key?(type)
	return num if num < 0
	return @const[type][num] || @ext_const[type][num]
end

def make_num_hash(from)
	hash = {}
	from.each_with_index {|v,i| hash[v]=i }
	hash
end

def num(type,x)
	raise "Unknown constant type `#{type}'" unless
		@const.has_key?(type) or
		@ext_const.has_key?(type)
	@const_num[type] = make_num_hash @const[type] unless
		const_num.has_key?(type)
	@const_num[type].fetch(x) {
		@ext_const_num[type].fetch(x) {
			x
		}
	}
end

def entry(name,&proc)
	[name,proc]
end

Attributes_ValueMask = [
	entry("background_pixmap") {|a1|
		a1 = %w( None ParentRelative ).index || a1
		pack "L", a1
	},
	entry("background_pixel") {|a1|
		pack "L", a1
	},
	entry("border_pixmap") {|a1|
		a1 = %w( CopyFromParent ).index || a1
		pack "L", a1
	},
	entry("border_pixel") {|a1|
		pack "L", a1
	}, 
	entry("bit_gravity") {|a1|
		a1 = a0->num("BitGravity", a1)
		pack Card8, a1
	},
	entry("win_gravity") {|a1|
		a1 = a0->num("WinGravity", a1)
		pack Card8, a1
	},
	entry("backing_store") {|a1|
		a1 = %w( NotUseful WhenMapped Always ).index || a1
		pack Card8, a1
	},
	entry("backing_planes") {|a1|
		pack "L", a1
	},
	entry("backing_pixel") {|a1|
		pack "L", a1
	},
	entry("override_redirect")|a1|
		pack Card8, a1
	},
	entry("save_under") {|a1|
		pack Card8, a1
	},
	entry("event_mask") {|a1|
		pack "L", a1
	},
	entry("do_not_propagate_mask") {|a1|
		pack "L", a1
	},
	entry("colormap") {|a1|
		a1 = %w( CopyFromParent ).index || a1
		pack "L", a1
	},
	entry("cursor") {|a1|
		a1 = %w( None ).index || a1
		pack "L", a1
	},
];

Configure_ValueMask = [
	entry("x",Int16),
	entry("y",Int16),
	entry("width",Card16),
	entry("height",Card16),
	entry("border_width",Card16),
	entry("sibling","L"),
	entry("stack_mode") {|a1|
		a1 = a0->num("StackMode", a1)
		pack Card8, a1
	}
],

packL = proc {|x| [x].pack "L" }
packInt16 = proc {|x| [x].pack Int16 }
packCard16 = proc {|x| [x].pack Card16 }

GC_ValueMask = [
	entry("function") {
		a1 = a0->num("GCFunction", a1);
		a1 = pack(Card8, a1);
	},
	entry("plane_mask","L"),
	entry("foreground","L"),
	entry("background","L"),
	entry("line_width",Card16),

	entry("line_style") {|a1| a1 = a0.num("GCLineStyle",a1); a1 = pack(Card8, a1) },
	entry( "cap_style") {|a1| a1 = a0.num("GCCapStyle" ,a1); a1 = pack(Card8, a1) },
	entry("join_style") {|a1| a1 = a0.num("GCJoinStyle",a1); a1 = pack(Card8, a1) },
	entry("fill_style") {|a1| a1 = a0.num("GCFillStyle",a1); a1 = pack(Card8, a1) },
	entry("fill_rule" ) {|a1| a1 = a0.num("GCFillRule" ,a1); a1 = pack(Card8, a1) },

	entry("tile"   ,"L"),
	entry("stipple","L"),
	entry("tile_stipple_x_origin",Int16),
	entry("tile_stipple_y_origin",Int16),
	entry("font",&packL),
	["subwindow_mode", proc {
	a1 = a0->num("GCSubwindowMode", a1);
	a1 = pack(Card8, a1);
	}],

	 ["graphics_exposures", proc {a1 = pack(Card8, a1);}, proc {}],
	entry("clip_x_origin", Int16),
	entry("clip_y_origin", Int16),
	entry("clip_mask") {
		a1 = 0 if a1 eq "None";
		a1 = pack("L", a1);
	},
	entry("dash_offset",Card16),
	entry("dashes",Card8),
	entry("arc_mode") {
		a1 = a0->num("GCArcMode", a1);
		a1 = pack(Card8, a1);
	},
]

KeyboardControl_ValueMask = [
	entry("key_click_percent",Int8),
	entry("bell_percent", Int8),
	entry("bell_pitch", Int16),
	entry("bell_duration", Int16),
	entry("led", Card8),
	entry("led_mode") { a1 = a0->num("LedMode", a1); a1 = pack(Card8, a1);},
	entry("key",Card8),
	entry("auto_repeat_mode") {
		a1 = a0->num("AutoRepeatMode", a1);
		a1 = pack(Card8, a1)
	}
]

def unpack_event(data)
	code,detail,seq = data[0,4].unpack "CCS"
	name, = do_interp("Events", code & 127)
	ret={
		"name" => name,
		"code" => code,
		"sequence_number" => seq,
	}
	ret["synthetic"] = 1 if code & 128
	code &= 127
	info = @events[$code] || @ext_events[$code];
	if info then
		i = info.dup
		if Proc===i[0] then
			ret = i[0].call self,data,ret
		else
			format,fields = i
			unpacked = data.unpack format
			f = nil
			fields.each {|f|
				if not ref f #!@#$
					ret[f] = unpacked.shift
				else					
					#!@#$
					if (ref $f[0] eq "CODE" or ref $f[1] eq "CODE")
						f[0].call ret if f[0]
					elsif not ref f[1]
						ret[f[0]] = interp(f[1], unpacked.shift)
					end
				else
					v = unpacked.shift
					v = f[1][v] if @do_interp and 
						(v==0 or v==1 && f[1][1])
					ret[f[0]] = v
				end
			}
		end
	else
		raise "Unknown event (code #{code})"
		ret["data"] = data
	end
	ret
end

def pack_event(*h)
	h = Hash[h]
	code = h.fetch(code) { num("Events", h[name]) }
	h["sequence_number"] ||= 0
	h["synthetic"] ||= 0
	data = nil; info = nil; do_seq = 1
		my($data, $info);
	info = @events[code] || @ext_events[code]
	if info
		i = info.dup
		if Proc===i[0] then
			data, do_seq = i[1].call self, h
		else
			format, fields = i
			topack = []
			f = nil
			fields.each {|f|
				#!@#$
				if not ref f
					topack.push, h[f]
				else
					f = f.dup
					if Proc===f[0] or Proc===f[1])
						f[1].call(h) if f[1]
					elsif not ref f[1]
						topack.push num(f[1], h[f[0]])
					else
						v = h[f[0]]
						v = 0 if v==f[1][0]
						v = 1 if v==f[1][1] and f[1][1]
						topack.push v
		else
			data = topack.pack format
		end
		data[2,2] = [h["sequence_number"]].pack "S" if do_seq
		data[0,1] = [code | (h["synthetic"] ? 128 : 0 )]
	else
		raise "Unknown event (code $code)!";
		return pack("Cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", $code);
	end
	return $data;
end

def unpack_event_mask(x)
	ans=[]
	Const["EventMask"].each{|i|
		ans.push i if x & 1
		x >>= 1
	}
	ans
end

def pack_event_mask(x)
	mask = 0
	x.each {|i|
		mask |= 1 << num("EventMask", i)
	}
	mask
end

def default_error_handler(data)
	type,seq,info,minor_op,major_op =
		data.unpack("xCSLSCxxxxxxxxxxxxxxxxxxxxx")
	t = join("", "Protocol error: $type (",
		  $self->do_interp("Error", $type), "); ",
		  "Sequence Number $seq\n",
		  " Opcode ($major_op, $minor_op) = ",
		  ($self->do_interp("Request", $major_op)
		  or @ext_request{$major_op}[$minor_op][0]), "\n");
	if type==2
		$t << " Bad value $info (#{hexi($info)})\n"
	elsif (@error_type[$type] & 1)
		$t << " Bad resource $info (#{hexi($info)})\n"
	end
	raise t
end

def handle_input
{
	my $self = shift;
	my($type_b, $type);
	$type_b = $self->get(1);
	$type = unpack "C", $type_b;
	if ($type == 0)
	{
	&{@error_handler}($self, $type_b . $self->get(31));
	return 0;
	}
	elsif ($type > 1)
	{
#	print STDERR "Got event -- type $type\n";
	if (@event_handler eq "queue")
	{
		push @{@event_queue}, $type_b . $self->get(31);
	}
	else
	{
		&{@event_handler}
		($self->unpack_event($type_b . $self->get(31)));
	}
	return -$type;
	}
	else # $type == 1
	{
#	print STDERR "Got reply\n";
	my($data) = $self->get(31);
	my($seq, $len) = unpack "SL", substr($data, 1, 6);
#	print STDERR "#$seq: Reading $len extra quads\n";
	$data = join("", $type_b, $data, $self->get(4 * $len));
	if (@replies->{$seq})
	{
		${@replies->{$seq}} = $data;
		return $seq;
	}
	else
	{
		raise "Unexpected reply to request $seq",
		" (of @sequence_num)"; 
#		print STDERR "[$data]\n";
		return $seq;
	}
	}
}

def dequeue_event
	data = event_queue.shift
	return [] unless data
	return unpack_event(data)
end

def next_event
	if (@event_handler ne "queue")
	{
	raise "Setting event_handler to "queue" to avoid infinite loop",
		 "in next_event()";
	@event_handler = "queue";
	}
	my(%e);
	$self->handle_input until %e = $self->dequeue_event;
	return %e;
end

def add_reply(seq,var)
	@replies[seq] = var
end

def delete_reply(seq)
	@replies.delete $seq
end

# the following procs all have a self (?)
Requests =

 #16
 ["InternAtom", proc {
	 my $self = shift;
	 my($string, $only_if_exists) = @_;
	 return pack("Sxx" . padded($string), length($string), $string),
			$only_if_exists;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($atom) = unpack("xxxxxxxxLxxxxxxxxxxxxxxxxxxxx", $data);
	 $atom = "None" if $atom == 0 and @do_interp;
	 return $atom;
 }],

 ["GetAtomName", proc {
	 my $self = shift;
	 my($atom) = @_;
	 return pack "L", $atom;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($len) = unpack "xxxxxxxxSxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32);
	 return substr($data, 32, $len);
 }],

 ["ChangeProperty", proc {
	 my $self = shift;
	 my($window, $property, $type, $format, $mode, $data) = @_;
	 $mode = $self->num("ChangePropertyMode", $mode);
	 my($x) = $format / 8;
	 return pack("LLLCxxxL" . padded($data), $window, $property, $type,
		 $format, length($data) / $x, $data), $mode;
 }],

 ["DeleteProperty", proc {
	 my $self = shift;
	 my($wid, $atom) = @_;
	 return pack "LL", $wid, $atom;
 }],

 ["GetProperty", proc {
	 my $self = shift;
	 my($wid, $prop, $type, $offset, $length, $delete) = @_;
	 $type = 0 if $type eq "AnyPropertyType";
	 return pack("LLLLL", $wid, $prop, $type, $offset, $length), $delete;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($format, $type, $bytes_after, $len) =
	 unpack "xCxxxxxxLLLxxxxxxxxxxxx", substr($data, 0, 32);
	 my($m) = $format / 8;
	 my($val) = substr($data, 32, $len * $m);
	 return ($val, $type, $format, $bytes_after);
 }],

 ["ListProperties", proc {
	 my $self = shift;
	 my($wid) = @_;
	 return pack "L", $wid;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack "xxxxxxxxSxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32);
	 return unpack "L*", substr($data, 32, $n * 4);
 }],

 #22
 ["SetSelectionOwner", proc {
	 my $self = shift;
	 my($selection, $owner, $time) = @_;
	 $owner = 0 if $owner eq "None";
	 $time = 0 if $time eq "CurrentTime";
	 return pack "LLL", $owner, $selection, $time;
 }],

 ["GetSelectionOwner", proc {
	 my $self = shift;
	 my($selection) = @_;
	 return pack "L", $selection;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($win) = unpack "xxxxxxxxLxxxxxxxxxxxxxxxxxxxx", $data;
	 $win = "None" if $win == 0 and @do_interp;
	 return $win;
 }],

 ["ConvertSelection", proc {
	 my $self = shift;
	 my($selection, $target, $prop, $requestor, $time) = @_;
	 $prop = 0 if $prop eq "None";
	 $time = 0 if $time eq "CurrentTime";
	 return pack("LLLLL", $requestor, $selection, $target, $prop, $time);
 }],

 #25
 ["SendEvent", proc {
	 my $self = shift;
	 my($destination, $propagate, $event_mask, $event) = @_;
	destinations = %w( PointerWindow InputFocus )
	 $destination = 0 if $destination eq "PointerWindow";
	 $destination = 1 if $destination eq "InputFocus";
	 return pack("LL", $destination, $event_mask) . $event, $propagate;
 }],

 #26
 ["GrabPointer", proc {
	 my $self = shift;
	 my($window, $owner_events, $event_mask, $pointer_mode, $keybd_mode,
	$confine_window, $cursor, $time) = @_;
	 $pointer_mode = $self->num("SyncMode", $pointer_mode);
	 $keybd_mode = $self->num("SyncMode", $keybd_mode);
	 $confine_window = 0 if $confine_window eq "None";
	 $cursor = 0 if $cursor eq "None";
	 $time = 0 if $time eq "CurrentTime";
	 return pack("LSCCLLL", $window, $event_mask, $pointer_mode, $keybd_mode,
		 $confine_window, $cursor, $time), $owner_events;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($status) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", $data);
	 return $self->interp("GrabStatus", $status);
 }],

 ["UngrabPointer", proc {
	 my $self = shift;
	 my($time) = @_;
	 $time = 0 if $time eq "CurrentTime";
	 return pack "L", $time;
 }],

 ["GrabButton", proc {
	 my $self = shift;
	 my($modifiers, $button, $win, $owner_events, $mask, $p_mode, $k_mode,
	$confine_w, $cursor) = @_;
	 $p_mode = $self->num("SyncMode", $p_mode);
	 $k_mode = $self->num("SyncMode", $k_mode);
	 $confine_w = 0 if $confine_w eq "None";
	 $cursor = 0 if $cursor eq "None";
	 $button = 0 if $button eq "AnyButton";
	 $modifiers = 0x8000 if $modifiers eq "AnyModifier";
	 return pack("LSCCLLCxS", $win, $mask, $p_mode, $k_mode, $confine_w,
		 $cursor, $button, $modifiers), $owner_events;
 }],

 ["UngrabButton", proc {
	 my $self = shift;
	 my($modifiers, $button, $win) = @_;
	 $button = 0 if $button eq "AnyButton";
	 $modifiers = 0x8000 if $modifiers eq "AnyModifier";
	 return pack("LSxx", $win, $modifiers), $button;
 }],

 #30
 ["ChangeActivePointerGrab", proc {
	 my $self = shift;
	 my($mask, $cursor, $time) = @_;
	 $cursor = 0 if $cursor eq "None";
	 $time = 0 if $time eq "CurrentTime";
	 return pack "LLSxx", $cursor, $time, $mask;
 }],

 ["GrabKeyboard", proc {
	 my $self = shift;
	 my($win, $owner_events, $p_mode, $k_mode, $time) = @_;
	 $time = 0 if $time eq "CurrentTime";
	 $p_mode = $self->num("SyncMode", $p_mode);
	 $k_mode = $self->num("SyncMode", $k_mode);
	 return pack("LLCCxx", $win, $time, $p_mode, $k_mode), $owner_events;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($status) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", $data);
	 return $self->interp("GrabStatus", $status);
 }],

 ["UngrabKeyboard", proc {
	 my $self = shift;
	 my($time) = @_;
	 $time = 0 if $time eq "CurrentTime";
	 return pack("L", $time);
 }],

 #33
 ["GrabKey", proc {
	 my $self = shift;
	 my($key, $modifiers, $win, $owner_events, $p_mode, $k_mode) = @_;
	 $modifiers = 0x8000 if $modifiers eq "AnyModifier";
	 $key = 0 if $key eq "AnyKey";
	 $p_mode = $self->num("SyncMode", $p_mode);
	 $k_mode = $self->num("SyncMode", $k_mode);
	 return pack("LSCCCxxx", $win, $modifiers, $key, $p_mode, $k_mode),
				 $owner_events;
 }],

 ["UngrabKey", proc {
	 my $self = shift;
	 my($key, $modifiers, $win) = @_;
	 $key = 0 if $key eq "AnyKey";
	 $modifiers = 0x8000 if $modifiers eq "AnyModifier";
	 return pack("LSxx", $win, $modifiers), $key;
 }],

 #35
 ["AllowEvents", proc {
	 my $self = shift;
	 my($mode, $time) = @_;
	 $mode = $self->num("AllowEventsMode", $mode);
	 $time = 0 if $time eq "CurrentTime";
	 return pack("L", $time), $mode;
 }],

 ["GrabServer", proc {
	 my $self = shift;
	 return "";
 }],

 ["UngrabServer", proc {
	 my $self = shift;
	 return "";
 }],

 #38
 ["QueryPointer", proc {
	 my $self = shift;
	 my($window) = @_;
	 return pack "L", $window;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($same_s, $root, $child, $root_x, $root_y, $win_x, $win_y, $mask)
	 = unpack "xCxxxxxxLLssssSxxxxxx", $data;
	 $child = "None" if $child == 0 and @do_interp;
	 return ("same_screen" => $same_s, "root" => $root, "child" => $child,
		 "root_x" => $root_x, "root_y" => $root_y, "win_x" => $win_x,
		 "win_y" => $win_y, "mask" => $mask);
 }],

 #39
 ["GetMotionEvents", proc {
	 my $self = shift;
	 my($start, $stop, $win) = @_;
	 $start = 0 if $start eq "CurrentTime";
	 $stop = 0 if $stop eq "CurrentTime";
	 return pack "LLL", $win, $start, $stop;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack "xxxxxxxxLxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32);
	 my($events) = substr($data, 32, 8 * $n);
	 my(@ret, $off);
	 for $off (0 .. $n - 1)
	 {
	 push @ret, [unpack "Lss", substr($events, 8 * $off, 8)];
	 }
	 return @ret;
 }],

 #40
 ["TranslateCoordinates", proc {
	 my $self = shift;
	 my($src_w, $dest_w, $src_x, $src_y) = @_;
	 return pack "LLss", $src_w, $dest_w, $src_x, $src_y;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($same_screen, $child, $dest_x, $dest_y) =
	 unpack "xCxxxxLssxxxxxxxxxxxxxxxx", $data;
	 $child = "None" if $child == 0 and @do_interp;
	 return ($same_screen, $child, $dest_x, $dest_y);
 }],

 ["WarpPointer", proc {
	 my $self = shift;
	 my($src_w, $dst_w, $src_x, $src_y, $src_width, $src_height, $dst_x,
	$dst_y) = @_;
	 $src_w = 0 if $src_w eq "None";
	 $dst_w = 0 if $dst_w eq "None";
	 return pack("LLssSSss", $src_w, $dst_w, $src_x, $src_y, $src_width,
		 $src_height, $dst_x, $dst_y);
 }],

 #42
 ["SetInputFocus", proc {
	 my $self = shift;
	 my($focus, $revert_to, $time) = @_;
	 $revert_to = $self->num("InputFocusRevertTo", $revert_to);
	 $focus = 0 if $focus eq "None";
	 $focus = 1 if $focus eq "ParentRoot";
	 $time = 0 if $time eq "CurrentTime";
	 return pack("LL", $focus, $time), $revert_to; 
 }],

 ["GetInputFocus", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($revert_to, $focus) =
	 unpack "xCxxxxxxLxxxxxxxxxxxxxxxxxxxx", $data;
	 $revert_to = $self->interp("InputFocusRevertTo", $revert_to);
	 $focus = "None" if $focus == 0 and @do_interp;
	 $focus = "PointerRoot" if $focus == 1 and @do_interp;
	 return ($focus, $revert_to);
 }],

 #44
 ["QueryKeymap", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 return substr($data, 8, 32);
 }],

 #49
 ["ListFonts", proc {
	 my $self = shift;
	 my($pat, $max) = @_;
	 return pack("SS" . padded($pat), $max, length($pat), $pat);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack("xxxxxxxxSxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32));
	 my($list) = substr($data, 32);
	 my(@ret, $offset, $len, $i);
	 $offset = 0;
	 while ($i++ < $n)
	 {
	 $len = unpack("C", substr($list, $offset, 1));
	 push @ret, substr($list, $offset + 1, $len);
	 $offset += $len + 1;
	 }
	 return @ret;
 }],

 #50
 ["ListFontsWithInfo", proc {
	 my $self = shift;
	 my($pat, $max) = @_;
	 return pack("SS" . padded($pat), $max, length($pat), $pat);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack("C", substr($data, 1, 1));
	 return () if $n == 0;
	 my($min_bounds) = substr($data, 8, 12);
	 my($max_bounds) = substr($data, 24, 12);
	 my($min_char_or_byte2, $max_char_or_byte2, $default_char, $m,
	$draw_direction, $min_byte1, $max_byte1, $all_chars_exist,
	$font_ascent, $font_descent) = unpack("SSSSCCCCssxxxx", 
						  substr($data, 40, 20));
	 my($properties) = substr($data, 60, 8 * $m);
	 my($name) = substr($data, 60 + 8 * $m, $n);
	 $draw_direction = $self->interp("DrawDirection", $draw_direction);
	 my(%ret) = ("min_char_or_byte2" => $min_char_or_byte2,
		 "max_char_or_byte2" => $max_char_or_byte2,
		 "default_char" => $default_char, 
		 "draw_direction" => $draw_direction,
		 "min_byte1" => $min_byte1, "max_byte1" => $max_byte1,
		 "all_chars_exist" => $all_chars_exist,
		 "font_ascent" => $font_ascent,
		 "font_descent" => $font_descent, "name" => $name);

	 $ret{"min_bounds"} = [unpack("sssssS", $min_bounds)];
	 $ret{"max_bounds"} = [unpack("sssssS", $max_bounds)];
	 my($i, %font_props);
	 for $i (0 .. $m - 1)
	 {
	 my($atom, $value) = unpack("LL", substr($properties, 8 * $i, 8));
	 $font_props{$atom} = $value;
	 }
	 $ret{"properties"} = {%font_props};
	 return %ret;
 }, "HASH"],

 #51
 ["SetFontPath", proc {
	 my $self = shift;
	 my(@dirs) = @_;
	 my($n, $d, $path);
	 for $d (@dirs)
	 {
	 $d = pack("C", length $d) . $d;
	 $n++;
	 }
	 $path = join("", @dirs);
	 return pack("Sxx" . padded($path), $n, $path);	 
 }],

 ["GetFontPath", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack("xxxxxxxxSxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32));
	 my($list) = substr($data, 32);
	 my(@ret, $offset, $len, $i);
	 $offset = 0;
	 while ($i++ < $n)
	 {
	 $len = unpack("C", substr($list, $offset, 1));
	 push @ret, substr($list, $offset + 1, $len);
	 $offset += $len + 1;
	 }
	 return @ret;	 
 }],

 #53
 ["CreatePixmap", proc {
	 my $self = shift;
	 my($pixmap, $drawable, $depth, $w, $h) = @_;
	 return pack("LLSS", $pixmap, $drawable, $w, $h), $depth; 
 }],

 ["FreePixmap", proc {
	 my $self = shift;
	 my($pixmap) = @_;
	 return pack "L", $pixmap;
 }],

 #55
 ["CreateGC", proc {
	 my $self = shift;
	 my($gc, $drawable, %values) = @_;
	 my($i, $mask, @values);
#	mask = look in GC_ValueMask for %values;
	mask = 0
	GC_ValueMask.each_index{|i|
		if values.has_key?(GC_ValueMask[i][0])
			mask |= 1 << i
			avalues << $GC_ValueMask[$i][1] .call (self, $values{$GC_ValueMask[$i][0]})
		 delete $values{$GC_ValueMask[$i][0]};
	 }
	 }
	 croak "Invalid GC components: ", join(",", keys %values), "\n" if %values;
	 return pack("LLL", $gc, $drawable, $mask) . join("", @values);
 }],

 ["ChangeGC", proc {
	 my $self = shift;
	 my($gc, %values) = @_;
	 my($i, $mask, @values);
	 $mask = 0;
	 for $i (0 .. $#GC_ValueMask)
	 {
	 if (exists $values{$GC_ValueMask[$i][0]})
	 {
		 $mask |= (1 << $i);
		 push @values, 
		   &{$GC_ValueMask[$i][1]}($self, $values{$GC_ValueMask[$i][0]});
	 }
	 }
	 return pack("LL", $gc,  $mask) . join("", @values);
 }],

 ["CopyGC", proc {
	 my $self = shift;
	 my($src, $dst, @values) = @_;
	 my(%values, $i, $mask);
	 $mask = 0;
	 @values{@values} = (1) x @values;
	 for $i (0 .. $#GC_ValueMask)
	 {
	 $mask |= (1 << $i) if exists $values{$GC_ValueMask[$i][0]};
	 }
	 return pack "LLL", $src, $dst, $mask;
 }],

 #58
 ["SetDashes", proc {
	 my $self = shift;
	 my($gc, $offset, @dashes) = @_;
	 my($dash_list) = pack("C*", @dashes);
	 my($n) = length $dash_list;
	 return pack("LSS" . padded($dash_list), $gc, $offset, $n, $dash_list);
 }],

 ["SetClipRectangles", proc {
	 my $self = shift;
	 my($gc, $clip_x_o, $clip_y_o, $ordering, @rects) = @_;
	 $ordering = $self->num("ClipRectangleOrdering", $ordering);
	 my($x);
	 for $x (@rects)
	 {
	 $x = pack("ssSS", @$x);
	 }
	 return pack("Lss", $gc, $clip_x_o, $clip_y_o) . join("", @rects),
			$ordering;
 }],

 ["FreeGC", proc {
	 my $self = shift;
	 my($gc) = @_;
	 return pack "L", $gc;
 }],

 #61
 ["ClearArea", proc {
	 my $self = shift;
	 my($win, $x, $y, $w, $h, $exposures) = @_;
	 return pack("LssSS", $win, $x, $y, $w, $h), $exposures;
 }],

 ["CopyArea", proc {
	 my $self = shift;
	 my($src_d, $dst_d, $gc, $src_x, $src_y, $w, $h, $dst_x, $dst_y) = @_;
	 return pack("LLLssssSS", $src_d, $dst_d, $gc, $src_x, $src_y, $dst_x,
		 $dst_y, $w, $h); 
 }],

 ["CopyPlane", proc {
	 my $self = shift;
	 my($src_d, $dst_d, $gc, $src_x, $src_y, $w, $h, $dst_x, $dst_y, $plane)
	 = @_;
	 return pack("LLLssssSSL", $src_d, $dst_d, $gc, $src_x, $src_y, $dst_x,
		 $dst_y, $w, $h, $plane); 
 }],

 #...

 #78
 ["CreateColormap", proc {
	 my $self = shift;
	 my($mid, $visual, $win, $alloc) = @_;
	 $alloc = 0 if $alloc eq "None";
	 $alloc = 1 if $alloc eq "All";
	 return pack("LLL", $mid, $win, $visual), $alloc;
 }],

 ["FreeColormap", proc {
	 my $self = shift;
	 my($cmap) = @_;
	 return pack("L", $cmap);
 }],

 ["CopyColormapAndFree", proc {
	 my $self = shift;
	 my($mid, $src) = @_;
	 return pack("LL", $mid, $src);
 }],

 ["InstallColormap", proc {
	 my $self = shift;
	 my($cmap) = @_;
	 return pack("L", $cmap);
 }],

 ["UninstallColormap", proc {
	 my $self = shift;
	 my($cmap) = @_;
	 return pack("L", $cmap);
 }],

 #83
 ["ListInstalledColormaps", proc {
	 my $self = shift;
	 my($win) = @_;
	 return pack("L", $win);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 return unpack("L*", substr($data, 32));
 }],

 #84
 ["AllocColor", proc {
	 my $self = shift;
	 my($cmap, $r, $g, $b) = @_;
	 return pack("LSSSxx", $cmap, $r, $g, $b);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($r, $g, $b, $pixel) = unpack("xxxxxxxxSSSxxLxxxxxxxxxxxx", $data);
	 return ($pixel, $r, $g, $b);
 }],

 ["AllocNamedColor", proc {
	 my $self = shift;
	 my($cmap, $name) = @_;
	 return pack("LSxx" . padded($name), $cmap, length($name), $name);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 return unpack("xxxxxxxxLSSSSSSxxxxxxxx", $data);
 }],

 ["AllocColorCells", proc {
	 my $self = shift;
	 my($cmap, $colors, $planes, $contig) = @_;
	 return pack("LSS", $cmap, $colors, $planes), $contig; 
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n,$m) = unpack("xxxxxxxxSSxxxxxxxxxxxxxxxxxxxx",substr($data, 0, 32));
	 return ([unpack("L*", substr($data, 32, 4 * $n))],
		 [unpack("L*", substr($data, 32 + 4 * $n, 4 * $m))]);
 }],

 ["AllocColorPlanes", proc {
	 my $self = shift;
	 my($cmap, $colors, $reds, $greens, $blues, $contig) = @_;
	 return pack("LSSSS", $cmap, $colors, $reds, $greens, $blues), $contig;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n, $r_mask, $g_mask, $b_mask) = 
	 unpack("xxxxxxxxSxxLLLxxxxxxxx", substr($data, 0, 32));
	 return ($r_mask, $g_mask, $b_mask, unpack("L*", substr($data, 32, 4*$n)));
 }],

 #88
 ["FreeColors", proc {
	 my $self = shift;
	 my($cmap, $mask, @pixels) = @_;
	 return pack("LLL*", $cmap, $mask, @pixels);
 }],

 ["StoreColors", proc {
	 my $self = shift;
	 my($cmap, @actions) = @_;
	 my($l, @l);
	 for $l (@actions)
	 {
	 @l = @$l;
	 if (@l == 4)
	 {
		 $l = pack("LSSSCx", @l, 7);
	 }
	 elsif (@l == 5)
	 {
		 $l = pack("LSSSCx", @l);
	 }
	 else
	 {
		 croak "Wrong # of items in arg to StoreColors";	 
	 }
	 }
	 return pack("L", $cmap) . join("", @actions);
 }],

 ["StoreNamedColor", proc {
	 my $self = shift;
	 my($cmap, $pixel, $name, $do) = @_;
	 return pack("LLSxx" . padded($name), $cmap, $pixel, length($name),
		 $name), $do;
 }],

 ["QueryColors", proc {
	 my $self = shift;
	 my($cmap, @pixels) = @_;
	 return pack("LL*", $cmap, @pixels);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack("xxxxxxxxSxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32));
	 my($i, @colors);
	 for $i (0 .. $n - 1)
	 {
	 push @colors, [unpack("SSSxx", substr($data, 32 + 8 * $i, 8))];
	 }
	 return @colors;
 }],

 #92
 ["LookupColor", proc {
	 my $self = shift;
	 my($cmap, $name) = @_;
	 return pack("LSxx" . padded($name), $cmap, length($name), $name);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 return unpack("xxxxxxxxSSSSSSxxxxxxxxxxxx", $data);
 }],

 #93
 ["CreateCursor", proc {
	 my $self = shift;
	 my($cid, $src, $mask, $fr, $fg, $fb, $br, $bg, $bb, $x, $y) = @_;
	 $mask = 0 if $mask eq "None";
	 return pack("LLLSSSSSSSS", $cid, $src, $mask, $fr, $fg, $fb, $br, $bg,
		 $bb, $x, $y);
 }],

 ["CreateGlyphCursor", proc {
	 my $self = shift;
	 my($cid, $src_fnt, $mask_fnt, $src_ch, $mask_ch, $fr, $fg, $fb, $br,
	$bg, $bb) = @_;;
	 $mask_fnt = 0 if $mask_fnt eq "None";
	 return pack("LLLSSSSSSSS", $cid, $src_fnt, $mask_fnt, $src_ch, $mask_ch,
		 $fr, $fg, $fb, $br, $bg, $bb);
 }],

 ["FreeCursor", proc {
	 my $self = shift;
	 my($cursor) = @_;
	 return pack("L", $cursor);
 }],

 ["RecolorCursor", proc {
	 my $self = shift;
	 my($cursor, $fr, $fg, $fb, $br, $bg, $bb) = @_;
	 return pack("LSSSSSS", $cursor, $fr, $fg, $fb, $br, $bg, $bb);
 }],

 #97
 ["QueryBestSize", proc {
	 my $self = shift;
	 my($class, $drawable, $w, $h) = @_;
	 $class = $self->num("SizeClass", $class);
	 return pack("LSS", $drawable, $w, $h), $class;
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($w, $h) = unpack("xxxxxxxxSSxxxxxxxxxxxxxxxxxxxx", $data);
	 return ($w, $h);
 }],

 #98
 ["QueryExtension", proc {
	 my $self = shift;
	 my($name) = @_;
	 return pack("Sxx" . padded($name), length($name), $name);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($present, $major, $event, $error) = 
	 unpack("xxxxxxxxCCCCxxxxxxxxxxxxxxxxxxxx", $data);
	 return () unless $present;
	 return ($major, $event, $error);
 }],

 #99
 ["ListExtensions", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($num) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",
			   substr($data, 0, 32));
	 my($list) = substr($data, 32);
	 my(@ret, $offset, $len, $i);
	 $offset = 0;
	 while ($i++ < $num)
	 {
	 $len = unpack("C", substr($list, $offset, 1));
	 push @ret, substr($list, $offset + 1, $len);
	 $offset += $len + 1;
	 }
	 return @ret;	 
 }],

 #100
 ["ChangeKeyboardMapping", proc {
	 my $self = shift;
	 my($first, $m, @info) = @_;
	 my($ar);
	 for $ar (@info)
	 {
	 $ar = pack("L$m", @{$ar}[0 .. $m - 1]);
	 }
	 return pack("CCxx", $first, $m) . join("", @info), scalar(@info);
 }],

 ["GetKeyboardMapping", proc {
	 my $self = shift;
	 my($first, $count) = @_;
	 return pack("CCxx", $first, $count);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n,$l) = unpack("xCxxLxxxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32));
	 my(@ret, $i);
	 for $i (0 .. $l/$n - 1)
	 {
	 push @ret, [unpack("L$n", substr($data, 32 + $i * $n * 4))];
	 }
	 return @ret;
 }],

 ["ChangeKeyboardControl", proc {
	 my $self = shift;
	 my(%values) = @_;
	 my($mask, $i, @values);
	 $mask = 0;
	 for $i (0 .. 7)
	 {
	 if (exists $values{$KeyboardControl_ValueMask[$i][0]})
	 {
		 $mask |= (1 << $i);
		 push @values, 
		 &{$KeyboardControl_ValueMask[$i][1]}
		 ($self, $values{$KeyboardControl_ValueMask[$i][0]});
	 }
	 }
	 return pack("L", $mask). join "", @values;
 }],

 ["GetKeyboardControl", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($global_auto_repeat, $led_mask, $key_click_percent, $bell_percent,
	$bell_pitch, $bell_duration) 
	 = unpack("xCxxxxxxLCCSSxx", substr($data, 0, 20));
	 my($auto_repeats) = substr($data, 20, 32);
	 return ("global_auto_repeat" =>
			$self->interp("LedMode", $global_auto_repeat),
		 "led_mask" => $led_mask,
		 "key_click_percent" => $key_click_percent,
		 "bell_percent" => $bell_percent, "bell_pitch" => $bell_pitch,
		 "bell_duration" => $bell_duration, 
		 "auto_repeats" => $auto_repeats);
 }],

 #104
 ["Bell", proc {
	 my $self = shift;
	 my($percent) = @_;
	 return "", unpack("C", pack("c", $percent)); # Ick
 }],

 ["ChangePointerControl", proc {
	 my $self = shift;
	 my($do_accel, $do_thresh, $num, $denom, $thresh) = @_;
	 return pack("sssCC", $num, $denom, $thresh, $do_accel, $do_thresh);
 }],

 ["GetPointerControl", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($num, $deno, $thresh) = unpack("xxxxxxxxSSSxxxxxxxxxxxxxxxxxx", $data);
	 return ($num, $deno, $thresh);
 }],

 ["SetScreenSaver", proc {
	 my $self = shift;
	 my($timeout, $interval, $pref_blank, $exposures) = @_;
	 $pref_blank = $self->num("ScreenSaver", $pref_blank);
	 $exposures = $self->num("ScreenSaver", $exposures);
	 return pack("ssCCxx", $timeout, $interval, $pref_blank, $exposures);
 }],

 ["GetScreenSaver", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($timeout, $interval, $pref_blank, $exposures) 
	 = unpack("xxxxxxxxSSCCxxxxxxxxxxxxxxxxxx", $data);
	 $pref_blank = $self->interp("ScreenSaver", $pref_blank);
	 $exposures = $self->interp("ScreenSaver", $exposures);
	 return ($timeout, $interval, $pref_blank, $exposures);
 }],

 #109
 ["ChangeHosts", proc {
	 my $self = shift;
	 my($mode, $family, $address) = @_;
	 $mode = $self->num("HostChangeMode", $mode);
	 $family = $self->num("HostFamily", $family);
	 return pack("CxS" . padded($address), $family, length($address),
		 $address), $mode;
 }],

 ["ListHosts", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($mode, $n) = unpack("xCxxxxxxSxxxxxxxxxxxxxxxxxxxxxx", 
				substr($data, 0, 32));
	 $mode = $self->interp("AccessMode", $mode);
	 my(@ret, $fam, $off, $l);
	 $off = 32;
	 while ($n-- > 0)
	 {
	 ($fam, $l) = unpack("CxS", substr($data, $off, 4));
	 $fam = $self->interp("HostFamily", $fam);
	 push @ret, [$fam, substr($data, $off + 4, $l)];
	 $off += 4 + $l + padding($l);
	 }
	 return ($mode, @ret);
 }],

 #111
 ["SetAccessControl", proc {
	 my $self = shift;
	 my($mode) = @_;
	 $mode = $self->num("AccessMode", $mode);
	 return "", $mode;
 }],

 ["SetCloseDownMode", proc {
	 my $self = shift;
	 my($mode) = @_;
	 $mode = $self->num("CloseDownMode", $mode);
	 return "", $mode;
 }],

 ["KillClient", proc {
	 my $self = shift;
	 my($rsrc) = @_;
	 $rsrc = 0 if $rsrc eq "AllTemporary";
	 return pack("L", $rsrc);
 }],

 ["RotateProperties", proc {
	 my $self = shift;
	 my($win, $delta, @atoms) = @_;
	 return pack("LSsL*", $win, scalar(@atoms), $delta, @atoms);
 }],

 ["ForceScreenSaver", proc {
	 my $self = shift;
	 my($mode) = @_;
	 $mode = $self->num("ScreenSaverAction", $mode);
	 return "", $mode;
 }],

 #116
 ["SetPointerMapping", proc {
	 my $self = shift;
	 my(@map) = @_;
	 my($map) = pack("C*", @map);
	 return pack(padded($map), $map), length($map); 
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($status) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", $data);
	 $status = $self->interp("MappingChangeStatus", $status);
	 return $status;
 }],

 ["GetPointerMapping", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32));
	 return unpack("C*", substr($data, 32, $n));
 }],

 ["SetModifierMapping", proc {
	 my $self = shift;
	 my(@keycodes) = @_;
	 my($kr);
	 for $kr (@keycodes)
	 {
	 $kr = pack("C8", @$kr);
	 }
	 return join("", @keycodes), scalar(@keycodes);
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($status) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", $data);
	 return $self->interp("MappingChangeStatus", $status);
 }],

 ["GetModifierMapping", proc {
	 my $self = shift;
	 return "";
 }, proc {
	 my $self = shift;
	 my($data) = @_;
	 my($n) = unpack("xCxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", substr($data, 0, 32));
	 my(@ret, $i);
	 for $i (0 .. $n - 1)
	 {
	 push @ret, [unpack("C8", substr($data, 32 + 8 * $i))];
	 }
	 return @ret;
 }],
 #120

 0, 0, 0, 0, 0, 0, 0,

 #127
 ["NoOperation", proc {
	 my $self = shift;
	 my($len) = @_;
	 $len = 1 unless defined $len;
	 return "\0" x (($len - 1) * 4);
 }]);

my($i);
for $i (0 .. 127)
{
	if (ref $Requests[$i] and $Requests[$i][0])
	{
	$Const{"Request"}[$i] = $Requests[$i][0];
	}
	else
	{
	$Const{"Request"}[$i] = "";
	}
}

def assemble_request
{
	my $self = shift;
	my($op, $args, $major, $minor) = (@_, 0);
	my($data);
	($data, $minor) = (&{$op->[1]}($self, @$args), $minor);
	$minor = 0 unless defined $minor;
	my($len) = (length($data) / 4) + 1;
	croak "Request too long!\n" if $len > @maximum_request_length;
	if ($len <= 65535)
	{
	return pack("CCS", $major, $minor, $len) . $data;
	}
	else
	{
	croak "Can't happen" unless @ext{"BIG_REQUESTS"};
	return pack("CCSL", $major, $minor, 0, $len) . $data;
	}
}

def send
{
	my $self = shift;
	my($name, @args) = @_;
	my($op, $major, $minor) = $self->get_request($name);
	$self->give($self->assemble_request($op, \@args, $major, $minor));
	return @sequence_num++;
}

def unpack_reply
{
	my $self = shift;
	my($name, $data) = @_;
	my($op) = $self->get_request($name);
	return &{$op->[2]}($self, $data);
}

def request
{
	my $self = shift;
	$self->req(@_);
}

def atom_name
{
	my $self = shift;
	my($num) = @_;
	if (@atom_names->[$num])
	{
	return @atom_names->[$num];
	}
	else
	{
	my($name) = $self->req("GetAtomName", $num);
	@atom_names->[$num] = $name;
	return $name;
	}
}

def atom
{
	my $self = shift;
	my($name) = @_;
	if (exists @atoms{$name})
	{
	return @atoms{$name};
	}
	else
	{
	my($atom) = $self->req("InternAtom", $name, 0);
	@atoms{$name} = $atom;
	return $atom;
	}
}

def choose_screen
{
	my $self = shift;
	my($screen) = @_;
	my($k);
	for $k (keys %{@screens[$screen]})
	{
	$self->{$k} = @screens[$screen]{$k};
	}
}

def init_extension
{
	my $self = shift;
	my($name) = @_;
	my($major, $event, $error) = $self->req("QueryExtension", $name)
	or return 0;
	$name =~ tr/-/_/;
	unless (defined eval { require("X11/Protocol/Ext/$name.pm") })
	{
	return 0 if substr($@, 0, 30) eq "Can't locate X11/Protocol/Ext/";
	croak($@);
	}
	my($pkg) = "X11::Protocol::Ext::$name";
	@ext{$name} = [$major, $event, $error,
				 $pkg->new($self, $major, $event, $error)];
}

def init_extensions
{
	my $self = shift;
	my($ext);
	for $ext ($self->req("ListExtensions"))
	{
	$self->init_extension($ext);
	}
}

1;
=begin

=head1 NAME

X11::Protocol - Perl module for the X Window System Protocol, version 11

=head1 SYNOPSIS

  use X11::Protocol;
  $x = X11::Protocol->new();
  $win = $x->new_rsrc;
  $x->CreateWindow($win, $x->root, "InputOutput",
		   $x->root_depth, "CopyFromParent",
		   ($x_coord, $y_coord), $width,
		   $height, $border_w);  
  ...

=head1 DESCRIPTION

X11::Protocol is a client-side interface to the X11 Protocol (see X(1) for
information about X11), allowing perl programs to display windows and
graphics on X11 servers.

A full description of the protocol is beyond the scope of this documentation;
for complete information, see the I<X Window System Protocol, X Version 11>,
available as Postscript or *roff source from C<ftp://ftp.x.org>, or
I<Volume 0: X Protocol Reference Manual> of O"Reilly & Associates"s series of
books about X (ISBN 1-56592-083-X, C<http://www.oreilly.com>), which contains
most of the same information.

=head1 DISCLAIMER

``The protocol contains many management mechanisms that are
not intended for normal applications.  Not all mechanisms
are needed to build a particular user interface.  It is
important to keep in mind that the protocol is intended to
provide mechanism, not policy."" -- Robert W. Scheifler

=head1 BASIC METHODS

=head2 new

  $x = X11::Protocol->new();
  $x = X11::Protocol->new($display_name);
  $x = X11::Protocol->new($connection);
  $x = X11::Protocol->new($display_name, [$auth_type, $auth_data]);
  $x = X11::Protocol->new($connection, [$auth_type, $auth_data]);

Open a connection to a server. $display_name should be an X display
name, of the form "host:display_num.screen_num"; if no arguments are
supplied, the contents of the DISPLAY environment variable are
used. Alternatively, a pre-opened connection, of one of the
X11::Protocol::Connection classes (see
L<X11::Protocol::Connection>,
L<X11::Protocol::Connection::FileHandle>,
L<X11::Protocol::Connection::Socket>,
L<X11::Protocol::Connection::UNIXFH>,
L<X11::Protocol::Connection::INETFH>,
L<X11::Protocol::Connection::UNIXSocket>,
L<X11::Protocol::Connection::INETSocket>) can be given. The
authorization data is obtained using X11::Auth or the second
argument. If the display is specified by $display_name, rather than
$connection, a choose_screen() is also performed, defaulting to screen
0 if the ".screen_num" of the display name is not present.  Returns
the new protocol object.

=head2 new_rsrc

  $x->new_rsrc;

Returns a new resource identifier. A unique resource ID is required for every
object that the server creates on behalf of the client: windows, fonts,
cursors, etc. (IDs are chosen by the client instead of the server for
efficiency -- the client doesn"t have to wait for the server to acknowledge
the creation before starting to use the object).

=head2 handle_input

  $x->handle_input;

Get one chunk of information from the server, and do something with it. If it"s
an error, handle it using the protocol object"s handler ("error_handler"
-- default is kill the program with an explanatory message). If it"s an event,
pass it to the chosen event handler, or put it in a queue if the handler is
"queue". If it"s a reply to a request, save using the object"s "replies" hash
for further processing.

=head2 atom_name

  $name = $x->atom_name($atom);

Return the string corresponding to the atom $atom. This is similar to the
GetAtomName request, but caches the result for efficiency.

=head2 atom

  $atom = $x->atom($name);

The inverse operation; Return the (numeric) atom correspoding to $name.
This is similar to the InternAtom request, but caches the result.

=head2 choose_screen

  $x->choose_screen($screen_num);

Indicate that you prefer to use a particular screen of the display. Per-screen
information, such as "root", "width_in_pixels", and "white_pixel" will be
made avaliable as 

  $x->{"root"}

instead of

  $x->{"screens"}[$screen_num]{"root"}

=head1 SYMBOLIC CONSTANTS

Generally, symbolic constants used by the protocol, like "CopyFromParent"
or "PieSlice" are passed to methods as strings, and
converted into numbers by the module.  Their names are the same as
those in the protocol specification, including capitalization, but
with hyphens ("-") changed to underscores ("_") to look more
perl-ish. If you want to do the conversion yourself for some reason,
the following methods are avaliable:

=head2 num

  $num = $x->num($type, $str)

Given a string representing a constant and a string specifying what
type of constant it is, return the corresponding number. $type should
be a name like "VisualClass" or "GCLineStyle". If the name is not
recognized, it is returned intact.

=head2 interp

  $name = $x->interp($type, $num)

The inverse operation; given a number and string specifying its type, return
a string representing the constant.

You can disable interp() and the module"s internal interpretation of
numbers by setting $x->{"do_interp"} to zero. Of course, this isn"t
very useful, unless you have you own definitions for all the
constants.

Here is a list of available constant types:

  AccessMode, AllowEventsMode, AutoRepeatMode, BackingStore,
  BitGravity, Bool, ChangePropertyMode, CirculateDirection,
  CirculatePlace, Class, ClipRectangleOrdering, CloseDownMode,
  ColormapNotifyState, CoordinateMode, CrossingNotifyDetail,
  CrossingNotifyMode, DeviceEvent, DrawDirection, Error, EventMask,
  Events, FocusDetail, FocusMode, GCArcMode, GCCapStyle, GCFillRule,
  GCFillStyle, GCFunction, GCJoinStyle, GCLineStyle, GCSubwindowMode,
  GrabStatus, HostChangeMode, HostFamily, ImageFormat,
  InputFocusRevertTo, KeyMask, LedMode, MapState, MappingChangeStatus,
  MappingNotifyRequest, PointerEvent, PolyShape, PropertyNotifyState,
  Request, ScreenSaver, ScreenSaverAction, Significance, SizeClass,
  StackMode, SyncMode, VisibilityState, VisualClass, WinGravity

=head1 SERVER INFORMATION

At connection time, the server sends a large amount of information about
itself to the client. This information is stored in the protocol object
for future reference. It can be read directly, like

  $x->{"release_number"}

or, for object oriented True Believers, using a method:

  $x->release_number

The method method also has a one argument form for setting variables, but
it isn"t really useful for some of the more complex structures.

Here is an example of what the object"s information might look like:

  "connection" => X11::Connection::UNIXSocket(0x814526fd),
  "byte_order" => "l",
  "protocol_major_version" => 11,
  "protocol_minor_version" => 0,
  "authorization_protocol_name" => "MIT-MAGIC-COOKIE-1",
  "release_number" => 3110,
  "resource_id_base" => 0x1c000002,
  "motion_buffer_size" => 0,
  "maximum_request_length" => 65535, # units of 4 bytes
  "image_byte_order" => "LeastSiginificant",
  "bitmap_bit_order" => "LeastSiginificant",
  "bitmap_scanline_unit" => 32,
  "bitmap_scanline_pad" => 32,
  "min_keycode" => 8,
  "max_keycode" => 134,
  "vendor" => "The XFree86 Project, Inc",
  "pixmap_formats" => {1 => {"bits_per_pixel" => 1,
				 "scanline_pad" => 32},
					   8 => {"bits_per_pixel" => 8,
				 "scanline_pad" => 32}},
  "screens" => [{"root" => 43, "width_in_pixels" => 800,
				 "height_in_pixels" => 600,
				 "width_in_millimeters" => 271,
				 "height_in_millmerters" => 203,
				 "root_depth" => 8,
				 "root_visual" => 34,
				 "default_colormap" => 33,
				 "white_pixel" => 0, "black_pixel" => 1,
				 "min_installed_maps" => 1,
				 "max_installed_maps" => 1,
				 "backing_stores" => "Always",
				 "save_unders" => 1,
				 "current_input_masks" => 0x58003d,
				 "allowed_depths" =>
					[{"depth" => 1, "visuals" => []},
					 {"depth" => 8, "visuals" => [
						{"visual_id" => 34, "blue_mask" => 0,
						 "green_mask" => 0, "red_mask" => 0, 
						 "class" => "PseudoColor",
						 "bits_per_rgb_value" => 6,
						 "colormap_entries" => 256},
						{"visual_id" => 35, "blue_mask" => 0xc0,
						 "green_mask" => 0x38, "red_mask" => 0x7, 
						 "class" => "DirectColor",
						 "bits_per_rgb_value" => 6,
						 "colormap_entries" => 8}, ...]}]],
  "visuals" => {34 => {"depth" => 8, "class" => "PseudoColor",
					   "red_mask" => 0, "green_mask" => 0,
					   "blue_mask"=> 0, "bits_per_rgb_value" => 6,
					   "colormap_entries" => 256},
				35 => {"depth" => 8, "class" => "DirectColor",
					   "red_mask" => 0x7, "green_mask" => 0x38,
					   "blue_mask"=> 0xc0, "bits_per_rgb_value" => 6,
					   "colormap_entries" => 8}, ...}
  "error_handler" => &\X11::Protocol::default_error_handler,
  "event_handler" => proc {},
  "do_interp" => 1


=head1 REQUESTS

=head2 request

  $x->request("CreateWindow", ...);
  $x->req("CreateWindow", ...);
  $x->CreateWindow(...);

Send a protocol request to the server, and get the reply. For names of and 
information about individual requests, see below and/or
the protocol reference manual.

=head2 add_reply

  $x->add_reply($sequence_num, \$var);

Add a stub for an expected reply to the object"s "replies" hash. When a reply
numbered $sequence_num comes, it will be stored in $var.

=head2 delete_reply

  $x->delete_reply($sequence_num);

Delete the entry in "replies" for the specified reply. (This should be done
after the reply is recieved).

=head2 send

  $x->send("CreateWindow", ...);

Send a request, but do not wait for a reply. You must handle the reply, if any,
yourself, using add_reply(), handle_input(), delete_reply(), and
unpack_reply(), generally in that order. 

=head2 unpack_reply

  $x->unpack_reply("GetWindowAttributes", $data);

Interpret the raw reply data $data, according to the reply format for the named
request. Returns data in the same format as C<request($request_name, ...)>.

This section includes only a short calling summary for each request; for
full descriptions, see the protocol standard. Argument order is usually the
same as listed in the spec, but you generally don"t have to pass lengths of
strings or arrays, since perl keeps track. Symbolic constants are generally
passed as strings. Most replies are returned as lists, but when there are
many values, a hash is used. Lists usually come last; when there is more than
one, each is passed by reference. In lists of multi-part structures, each
element is a list ref. Parenthesis are inserted in arg lists for clarity,
but are optional. Requests are listed in order by major opcode, so related
requests are usually close together. Replies follow the "=>".

  $x->CreateWindow($wid, $parent, $class, $depth, $visual, ($x, $y),
		   $width, $height, $border_width,
 		   "attribute" => $value, ...)

  $x->ChangeWindowAttributes($window, "attribute" => $value, ...)

  $x->GetWindowAttributes($window)
  =>
  ("backing_store" => $backing_store, ...)

This is an example of a return value that is meant to be assigned to a hash.

  $x->DestroyWindow($win)

  $x->DestroySubwindows($win)

  $x->ChangeSaveSet($window, $mode)

  $x->ReparentWindow($win, $parent, ($x, $y))

  $x->MapWindow($win)

  $x->MapSubwindows($win)

  $x->UnmapWindow($win)

  $x->UnmapSubwindows($win)

  $x->ConfigureWindow($win, "attribute" => $value, ...)

  $x->CirculateWindow($win, $direction)

Note that this request actually circulates the subwindows of $win,
not the window itself.

  $x->GetGeometry($drawable)
  =>
  ("root" => $root, ...)

  $x->QueryTree($win)
  =>
  ($root, $parent, @kids)

  $x->InternAtom($name, $only_if_exists)
  =>
  $atom

  $x->GetAtomName($atom)
  =>
  $name

  $x->ChangeProperty($window, $property, $type, $format, $mode, $data)

  $x->DeleteProperty($win, $atom)

  $x->GetProperty($window, $property, $type, $offset, $length, $delete)
  =>
  ($value, $type, $format, $bytes_after)

Notice that the value comes first, so you can easily ignore the rest.

  $x->ListProperties($window)
  =>
  (@atoms)

  $x->SetSelectionOwner($selection, $owner, $time)

  $x->GetSelectionOwner($selection)
  =>
  $owner

  $x->ConvertSelection($selection, $target, $property, $requestor, $time)

  $x->SendEvent($destination, $propagate, $event_mask, $event)

The $event argument should be the result of a pack_event() (see L<"EVENTS">)

  $x->GrabPointer($grab_window, $owner_events, $event_mask,
		  $pointer_mode, $keyboard_mode, $confine_to,
		  $cursor, $time)
  =>
  $status

  $x->UngrabPointer($time)

  $x->GrabButton($modifiers, $button, $grab_window, $owner_events,
		 $event_mask, $pointer_mode, $keyboard_mode,
		 $confine_to, $cursor)

  $x->UngrabButton($modifiers, $button, $grab_window)

  $x->ChangeActivePointerGrab($event_mask, $cursor, $time)

  $x->GrabKeyboard($grab_window, $owner_events, $pointer_mode,
		   $keyboard_mode, $time)
  =>
  $status

  $x->UngrabKeyboard($time)

  $x->GrabKey($key, $modifiers, $grab_window, $owner_events,
		  $pointer_mode, $keyboard_mode)

  $x->UngrabKey($key, $modifiers, $grab_window)

  $x->AllowEvents($mode, $time)

  $x->GrabServer

  $x->UngrabServer

  $x->QueryPointer($window)
  =>
  ("root" => $root, ...)

  $x->GetMotionEvents($start, $stop, $window)
  =>
  ([$time, ($x, $y)], [$time, ($x, $y)], ...)

  $x->TranslateCoordinates($src_window, $dst_window, $src_x, $src_y)
  =>
  ($same_screen, $child, $dst_x, $dst_y)

  $x->WarpPointer($src_window, $dst_window, $src_x, $src_y, $src_width,
		  $src_height, $dst_x, $dst_y)

  $x->SetInputFocus($focus, $revert_to, $time)

  $x->GetInputFocus
  =>
  ($focus, $revert_to)

  $x->QueryKeymap
  =>
  $keys

$keys is a bit vector, so you should use vec() to read it.

  $x->OpenFont($fid, $name)

  $x->CloseFont($font)

  $x->QueryFont($font)
  =>
  ("min_char_or_byte2" => $min_char_or_byte2,
   ..., 
   "min_bounds" =>
   [$left_side_bearing, $right_side_bearing, $character_width, $ascent,
	$descent, $attributes],
   ...,
   "char_infos" =>
   [[$left_side_bearing, $right_side_bearing, $character_width, $ascent,
	 $descent, $attributes], 
	...], 
   "properties" => {$prop => $value, ...}
   )

  $x->QueryTextExtents($font, $string)
  =>
  ("draw_direction" => $draw_direction, ...)

  $x->ListFonts($pattern, $max_names)
  =>
  @names

  $x->ListFontsWithInfo($pattern, $max_names)
  =>
  ({"name" => $name, ...}, {"name" => $name, ...}, ...)

The information in each hash is the same as the the information returned by
QueryFont, but without per-character size information. This request is
special in that it is the only request that can have more than one reply.
This means you should probably only use request() with it, not send(), as
the reply counting is complicated. Luckily, you never need this request
anyway, as its function is completely duplicated by other requests.

  $x->SetFontPath(@strings)

  $x->GetFontPath
  =>
  @strings

  $x->CreatePixmap($pixmap, $drawable, $depth, $width, $height)

  $x->FreePixmap($pixmap)

  $x->CreateGC($cid, $drawable, "attribute" => $value, ...)

  $x->ChangeGC($gc, "attribute" => $value, ...)

  $x->CopyGC($src, $dest, "attribute", "attribute", ...)

  $x->SetDashes($gc, $dash_offset, (@dashes))

  $x->SetClipRectangles($gc, ($clip_x_origin, $clip_y_origin),
			$ordering, [$x, $y, $width, $height], ...)

  $x->ClearArea($window, ($x, $y), $width, $height, $exposures)

  $x->CopyArea($src_drawable, $dst_drawable, $gc, ($src_x, $src_y),
		   $width, $height, ($dst_x, $dst_y))

  $x->CopyPlane($src_drawable, $dst_drawable, $gc, ($src_x, $src_y),
		$width, $height, ($dst_x, $dst_y), $bit_plane)

  $x->PolyPoint($drawable, $gc, $coordinate_mode,
		($x, $y), ($x, $y), ...)

  $x->PolyLine($drawable, $gc, $coordinate_mode,
		   ($x, $y), ($x, $y), ...)

  $x->PolySegment($drawable, $gc, ($x, $y) => ($x, $y),
		  ($x, $y) => ($x, $y), ...)

  $x->PolyRectangle($drawable, $gc,
			[($x, $y), $width, $height], ...)

  $x->PolyArc($drawable, $gc,
		  [($x, $y), $width, $height, $angle1, $angle2], ...)

  $x->FillPoly($drawable, $gc, $shape, $coordinate_mode,
		   ($x, $y), ...)

  $x->PolyFillRectangle($drawable, $gc,
			[($x, $y), $width, $height], ...)

  $x->PolyFillArc($drawable, $gc,
		  [($x, $y), $width, $height, $angle1, $angle2], ...)

  $x->PutImage($drawable, $gc, $depth, $width, $height,
		   ($dst_x, $dst_y), $left_pad, $format, $data)

Currently, the module has no code to handle the various bitmap formats that
the server might specify. Therefore, this request will not work portably
without a lot of work.

  $x->GetImage($drawable, ($x, $y), $width, $height, $plane_mask,
		   $format)

  $x->PolyText8($drawable, $gc, ($x, $y),
		($font OR [$delta, $string]), ...)

  $x->PolyText16($drawable, $gc, ($x, $y),
		 ($font OR [$delta, $string]), ...)

  $x->ImageText8($drawable, $gc, ($x, $y), $string)

  $x->ImageText16($drawable, $gc, ($x, $y), $string)

  $x->CreateColormap($mid, $visual, $window, $alloc)

  $x->FreeColormap($cmap)

  $x->CopyColormapAndFree($mid, $src_cmap)

  $x->InstallColormap($cmap)

  $x->UninstallColormap($cmap)

  $x->ListInstalledColormaps($window)
  =>
  @cmaps

  $x->AllocColor($cmap, ($red, $green, $blue))
  =>
  ($pixel, ($red, $green, $blue))

  $x->AllocNamedColor($cmap, $name)
  =>
  ($pixel, ($exact_red, $exact_green, $exact_blue),
   ($visual_red, $visual_green, $visual_blue))

  $x->AllocColorCells($cmap, $colors, $planes, $contiguous)
  =>
  ([@pixels], [@masks])

  $x->AllocColorPlanes($cmap, $colors, ($reds, $greens, $blues),
			   $contiguous)
  =>
  (($red_mask, $green_mask, $blue_mask), @pixels)

  $x->FreeColors($cmap, $plane_mask, @pixels)

  $x->StoreColors($cmap, [$pixel, $red, $green, $blue, $do_mask], ...)

The 1, 2, and 4 bits in $mask are do-red, do-green, and do-blue. $mask can
be omitted, defaulting to 7, the usual case -- change the whole color.

  $x->StoreNamedColor($cmap, $pixel, $name, $do_mask)

$do_mask has the same interpretation as above, but is mandatory.

  $x->QueryColors($cmap, @pixels)
  =>
  ([$red, $green, $blue], ...)

  $x->LookupColor($cmap, $name)
  =>
  (($exact_red, $exact_green, $exact_blue),
   ($visual_red, $visual_green, $visual_blue)) 

  $x->CreateCursor($cid, $source, $mask,
		   ($fore_red, $fore_green, $fore_blue),
		   ($back_red, $back_green, $back_blue),
		   ($x, $y))

  $x->CreateGlyphCursor($cid, $source_font, $mask_font,
			$source_char, $mask_char,
			($fore_red, $fore_green, $fore_blue),
			($back_red, $back_green, $back_blue))
			
  $x->FreeCursor($cursor)

  $x->RecolorCursor($cursor, ($fore_red, $fore_green, $fore_blue),
			($back_red, $back_green, $back_blue))

  $x->QueryBestSize($class, $drawable, $width, $height)
  =>
  ($width, $height)

  $x->QueryExtension($name)
  =>
  ($major_opcode, $first_event, $first_error)

If the extension is not present, an empty list is returned.

  $x->ListExtensions
  =>
  (@names)

  $x->ChangeModifierMapping($first_keycode, $keysysms_per_keycode,
				@keysyms)

  $x->GetKeyboardMapping($first_keycode, $count)
  =>
  ($keysysms_per_keycode, [$keysym, ...], [$keysym, ...], ...)

  $x->ChangeKeyboardControl("attribute" => $value, ...)

  $x->GetKeyboardControl
  =>
  ("global_auto_repeat" => $global_auto_repeat, ...)

  $x->Bell($percent)

  $x->ChangePointerControl($do_acceleration, $do_threshold,
			   $acceleration_numerator,
			   $acceleration_denominator, $threshold)

  $x->GetPointerControl
  =>
  ($accerleration_numerator, $acceleration_denominator, $threshold)

  $x->SetScreenSaver($timeout, $interval, $prefer_blanking,
			 $allow_exposures)

  $x->GetScreenSaver
  =>
  ($timeout, $interval, $prefer_blanking, $allow_exposures)

  $x->ChangeHosts($mode, $host_family, $host_address) 

  $x->ListHosts
  =>
  ($mode, [$family, $host], ...)

  $x->SetAccessControl($mode)

  $x->SetCloseDownMode($mode)

  $x->KillClient($resource)

  $x->RotateProperties($win, $delta, @props)

  $x->ForceScreenSaver($mode)

  $x->SetPointerMapping(@map)
  =>
  $status

  $x->GetPointerMapping
  =>
  @map  

  $x->SetModifierMapping(@keycodes)
  =>
  $status

  $x->GetModiferMapping
  =>
  @keycodes

  $x->NoOperation($length)

$length specifies the length of the entire useless request, in four byte units,
and is optional.

=head1 EVENTS

To receive events, first set the "event_mask" attribute on a window to
indicate what types of events you desire (see
L<"pack_event_mask">). Then, set the protocol object"s "event_handler"
to a subroutine reference that will handle the events. Alternatively,
set "event_handler" to "queue", and retrieve events using
dequeue_event(). In both cases, events are returned as a hash. For
instance, a typical MotionNotify event might look like this:

  %event = ("name" => "MotionNotify", "sequence_number" => 12,
			"state" => 0, "event" => 58720256, "root" => 43,
			"child" => None, "same_screen" => 1, "time" => 966080746,
			"detail" => "Normal", "event_x" => 10, "event_y" => 3,
			"code" => 6, "root_x" => 319, "root_y" => 235)

=head2 pack_event_mask

  $mask = $x->pack_event_mask("ButtonPress", "KeyPress", "Exposure");

Make an event mask (suitable as the "event_mask" of a window) from a list
of strings specifying event types.

=head2 unpack_event_mask

  @event_types = $x->unpack_event_mask($mask);

The inverse operation; convert an event mask obtained from the server into a
list of names of event categories.

=head2 dequeue_event

  %event = $x->dequeue_event;

If there is an event waiting in the queue, return it.

=head2 next_event

  %event = $x->next_event;

Like Xlib"s XNextEvent(), this function is equivalent to

  $x->handle_input until %event = dequeue_event;

=head2 pack_event

  $data = $x->pack_event(%event);

Given an event in hash form, pack it into a string. This is only useful as
an argument to SendEvent().

=head2 unpack_event

  %event = $x->unpack_event($data);

The inverse operation; given the raw data for an event (32 bytes), unpack it
into hash form. Normally, this is done automatically.

=head1 EXTENSIONS

Protocol extensions add new requests, event types, and error types to
the protocol. Support for them is compartmentalized in modules in the
X11::Protocol::Ext:: hierarchy. For an example, see
L<X11::Protocol::Ext:SHAPE>. You can tell if the module has loaded an
extension by looking at

  $x->{"ext"}{$extension_name}

If the extension has been initialized, this value will be an array reference,
[$major_request_number, $first_event_number, $first_error_number, $obj], where
$obj is an object containing information private to the extension. 

=head2 init_extension

  $x->init_extension($name);

Initialize an extension: query the server to find the extension"s request
number, then load the corresponding module. Returns 0 if the server does
not support the named extension, or if no module to interface with it exists.

=head2 init_extensions

  $x->init_extensions;

Initialize protocol extensions. This does a ListExtensions request, then calls
init_extension() for each extension that the server supports.

=head1 WRITING EXTENSIONS

Internally, the X11::Protocol module is table driven. All an extension has to
do is to add new add entries to the protocol object"s tables. An extension
module should C<use X11::Protocol>, and should define an new() method

  X11::Protocol::Ext::NAME
	->new($x, $request_num, $event_num, $error_num)

where $x is the protocol object and $request_num, $event_num and $error_num
are the values returned by QueryExtension().

The new() method should add new types of constant like

  $x->{"ext_const"}{"ConstantType"} = ["Constant", "Constant", ...]

and set up the corresponding name to number translation hashes like

  $x->{"ext_const_num"}{"ConstType"} =
	{make_num_hash($x->{"ext_const"}{"ConstType"})}

Event names go in

  $x->{"ext_const"}{"Events"}[$event_number]

while specifications for event contents go in

  $x->{"ext_event"}[$event_number]

each element of which is either C<[\&unpack_sub, \&pack_sub]> or
C<[$pack_format, $field, $field, ...]>, where each $field is C<"name">,
C<["name", "const_type"]>, or C<["name", ["special_name_for_zero",
"special_name_for_one"]]>, where C<"special_name_for_one"> is optional.

Finally,

  $x->{"ext_request"}{$major_request_number}

should be an array of arrays, with each array either C<[$name, \&packit]> or
C<[$name, \&packit, \&unpackit]>, and

  $x->{"ext_request_num"}{$request_name}

should be initialized with C<[$minor_num, $major_num]> for each request the
extension defines. For examples of code that does all of this, look at
X11::Protocol::Ext::SHAPE.

X11::Protocol exports several functions that might be useful in extensions
(note that these are I<not> methods).

=head2 padding

  $p = padding $x;

Given an integer, compute the number need to round it up to a multiple of 4.
For instance, C<padding(5)> is 3.

=head2 pad

  $p = pad $str;

Given a string, return the number of extra bytes needed to make a multiple
of 4. Equivalent to C<padding(length($str))>.

=head2 padded

  $data = pack(padded($str), $str);

Return a format string, suitable for pack(), for a string padded to a multiple
of 4 bytes. For instance, C<pack(padded("Hello"), "Hello")> gives
C<"Hello\0\0\0">.

=head2 hexi

  $str = hexi $n;

Format a number in hexidecimal, and add a "0x" to the front.

=head2 make_num_hash

  %hash = make_num_hash(["A", "B", "C"]);

Given a reference to a list of strings, return a hash mapping the strings onto
numbers representing their position in the list, as used by
C<$x-E<gt>{"ext_const_num"}>.

=head1 BUGS

This module is too big (~2500 lines), too slow (10 sec to load on a slow
machine), too inefficient (request args are copied several times), and takes
up too much memory (3000K for basicwin).

If you have more than 65535 replies outstanding at once, sequence numbers
can collide.

The protocol is too complex.

=head1 AUTHOR

Stephen McCamant <alias@mcs.com>.

=head1 SEE ALSO

L<perl(1)>,
L<X(1)>, 
L<X11::Keysyms>, 
L<X11::Protocol::Ext::SHAPE>,
L<X11::Protocol::Ext::BIG_REQUESTS>,
L<X11::Auth>,
I<X Window System Protocol (X Version 11)>,
I<Inter-Client Communications Conventions Manual>,
I<X Logical Font Description Conventions>.

=cut
