require "X11/Display"

$d = X11::Display.new
$s = $d.display_info.screens[0]
$dp = $s.depths.find {|dp| dp.depth > 1 }

$attribs = X11::WindowAttributes.new(
	:background_pixel => $s.white_pixel,
	:bit_gravity => :Static,
	:event_mask =>
		X11::EventMask.lookup(
			:Exposure, :KeyPress,
			:ButtonPress, :StructureNotify)
	)

$ws = (0...3).map {
	w = X11::Window.new($d)
	w.create($s.root, X11::Rect[X11::Point[0,0],X11::Size[320,240]],
		4, $dp.depth, :InputOutput, :CopyFromParent, $attribs)
	w.map
	w
}

loop do
	# receive events
	$d.xreceive_blocking
	# discard events
	nil while $d.next_event
end
